//+--------------------------------------------------------------------------------------------+
//|                                                                       Choppiness Index.mq4 |
//|                                                             Copyright  2011, Serega Lykov |
//|                                                                 http://mtexperts.narod.ru/ |
//+--------------------------------------------------------------------------------------------+

#property copyright "Copyright  2011, Serega Lykov"
#property link      "http://mtexperts.narod.ru/"

/*
{ CI: Choppiness Index }
input Len = 14;
input CIx = {default CI3, CI2};
def CI2 = 100 * log(Sum(TrueRange(high,close,low),Len)) / (Highest(close[1],Len) - Lowest(close[1],Len)) / log(Len);
def CI3 = ((log(Sum(TrueRange(high,close,low),Len) / (Highest(if high >= close[1] then high else close[1],Len) - Lowest(if low <= close[1] then low else close[1],Len))) / log(10)) / (log(Len)/log(10))) * 100;
plot CI = if CIx == CIx.CI3 then CI3 else CI2;
CI.AssignValueColor( Color.Blue);
plot line60 = 60;
line60.AssignValueColor(Color.DARK_GREEN);
plot line35 = 35;
line35.AssignValueColor(Color.BLACK);
plot line25 = 25;
line25.AssignValueColor(Color.DARK_RED);
*/

//----   --------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Gold

//----   ----------------------------------------------------------------------+
extern int    Indicator_Period                = 14;
extern bool   CalculateCI2                    = true;

//----   ----------------------------------------------------------------------+
static double CI[];
static double ATR[];
static double SumATR[];

//-----   -----------------------------------------------------------------+
static double divider;

//---------------------------------------------------------------------------------------------+
//----   ---------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int init()
  {
   //----  ""   ----------------------------------------------+
   if(CalculateCI2) string ind_name = "CI2";
   else ind_name = "CI3";
   IndicatorShortName(StringConcatenate(ind_name,"(",DoubleToStr(Indicator_Period,0),")"));
   //---- 2   ------------------------------------------------------------+
   IndicatorBuffers(3);
   //----     ----------------------------------------------+
   IndicatorDigits(4);
   //----     ----------------------------------------------------+
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   //----      ---------------------------------------------+
   SetIndexBuffer(0,CI);
   SetIndexBuffer(1,ATR);
   SetIndexBuffer(2,SumATR);
   //----     --------------------------------------------------------+
   SetIndexLabel(0,StringConcatenate(ind_name,"(",DoubleToStr(Indicator_Period,0),")"));
   //----       --------------------------------+
   SetIndexDrawBegin(0,Indicator_Period);
   //----    --------------------------------------------------------+
   SetLevelValue(0,25);
   SetLevelValue(1,35);
   SetLevelValue(2,60);
   SetLevelStyle(STYLE_DOT,1,White);
   //----   ----------------------------------------------------------------+
   double log_10 = MathLog(10);
   if(CalculateCI2) divider = log_10 / 100.0;
   else divider = log_10 * (MathLog(Indicator_Period) / log_10) / 100.0;
   //----   -----------------------------------------------------------------+
   return(0);
   Print("---- Programming by Serega Lykov, http://mtexperts.narod.ru/ ----");
  }

//---------------------------------------------------------------------------------------------+
//----   -------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//---------------------------------------------------------------------------------------------+
//---- start ----------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int start()
  {
   //----        --------------------+
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   //----      ------------------------------------------+
   if(counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   //----   TrueRange ---------------------------------------------------------+
   for(int i=limit; i>=0; i--) ATR[i] = iATR(NULL,0,1,i);
   //----    TrueRange --------------------------------------------------+
   for(i=limit; i>=0; i--)
     {
      SumATR[i] = 0.0;
      for(int k=0; k<Indicator_Period; k++) SumATR[i] += ATR[i+k];
     }
   //----    -------------------------------------------------------+
   for(i=limit; i>=0; i--)
     {
      if(CalculateCI2)
        {
         double highest = Close[iHighest(NULL,0,MODE_CLOSE,Indicator_Period,i+1)];
         double lowest  = Close[iLowest( NULL,0,MODE_CLOSE,Indicator_Period,i+1)];
        }
      else
        {
         if(High[i] >= Close[i+1]) highest = High[iHighest(NULL,0,MODE_HIGH,Indicator_Period,i)];
         else highest = Close[iHighest(NULL,0,MODE_CLOSE,Indicator_Period,i+1)];
         if(Low[i] <= Close[i+1]) lowest = Low[iLowest(NULL,0,MODE_LOW,Indicator_Period,i)];
         else lowest = Close[iLowest(NULL,0,MODE_CLOSE,Indicator_Period,i+1)];
        }
      if(highest == lowest) CI[i] = EMPTY_VALUE;
      else CI[i] = MathLog(SumATR[i] / (highest - lowest)) / divider;
     }
   //----   -----------------------------------------------------------------+
   return(0);
  }

//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+